#include "format.h"

using namespace std;

void FormatString( const FormatList &format, LPSTR lpBuf, int size, HWND hFittle )
{
	ostrstream oss;

	for( FormatList::const_iterator itr = format.begin(); itr != format.end(); ++itr )
	{
		switch( itr->first )
		{
		case FORMAT_STRING:
			oss << itr->second;
			break;
		case FORMAT_TITLE:
			oss << (char *)SendMessage( hFittle, WM_FITTLE, GET_TITLE, 0 );
			break;
		case FORMAT_ARTIST:
			oss << (char *)SendMessage( hFittle, WM_FITTLE, GET_ARTIST, 0 );
			break;
		case FORMAT_PATH:
			oss << (char*)SendMessage( hFittle, WM_FITTLE, GET_PLAYING_PATH, 0 );
			break;
		case FORMAT_POSITION:
			{
				int pos = (int)SendMessage( hFittle, WM_FITTLE, GET_POSITION, 0 );
				oss << ( pos / 60 ) << ":" << setw(2) << setfill('0') << ( pos % 60 );
			}
			break;
		case FORMAT_DURATION:
			{
				int dur = (int)SendMessage( hFittle, WM_FITTLE, GET_DURATION, 0 );
				oss << ( dur / 60 ) << ":" << setw(2) << setfill('0') << ( dur % 60 );
			}
			break;
		}
	}
	//'\0'ŕ
	oss << ends;

	strncpy( lpBuf, oss.str(), size );
	lpBuf[size - 1] = '\0';
}


//p[X std::string̓_肪邩CStringgĂ݂
void ParseFormat( FormatList &format, const CString &strformat )
{
	int i = 0;
	int start = 0;
	int end = 0;
	
	while( 1 )
	{
		start = strformat.Find( '%', end );
		if( start != -1 )
		{
			if( start != end )
				format.push_back( 
					make_pair< int, CString >( FORMAT_STRING, strformat.Mid( end, start - end ) ) );

			end = strformat.Find( '%', start + 1 );
			if( end != -1 )
			{
				//% % ŋ܂ꂽ؂o
				CString e = strformat.Mid( start + 1, end - start - 1 );
				end++;
				if( e == "TITLE" )
					format.push_back( make_pair< int, CString >( FORMAT_TITLE, CString() ) );
				else if( e == "ARTIST" )
					format.push_back( make_pair< int, CString >( FORMAT_ARTIST, CString() ) );
				else if( e == "PATH" )
					format.push_back( make_pair< int, CString >( FORMAT_PATH, CString() ) );
				else if( e == "POSITION" )
					format.push_back( make_pair< int, CString >( FORMAT_POSITION, CString() ) );
				else if( e == "DURATION" )
					format.push_back( make_pair< int, CString >( FORMAT_DURATION, CString() ) );
				else if( e == "" ) // "%%""%"Ƃďo
					format.push_back( make_pair< int, CString >( FORMAT_STRING, CString("%") ) );
				else               //vȂ
					format.push_back( make_pair< int, CString >( FORMAT_STRING, CString("G[") ) );
			}
			else//܂ĂȂ
				format.push_back( make_pair< int, CString >( FORMAT_STRING, CString("G[") ) );
		}
		else
			break;
	}
	
	if( end  != strformat.GetLength() )
		format.push_back( make_pair< int, CString >( FORMAT_STRING, strformat.Mid( end ) ) );
}

